.\"	$NetBSD: wsconscfg.8,v 1.19 2006/06/24 21:03:57 wiz Exp $
.\"
.\" Copyright (c) 1999
.\" 	Matthias Drochner.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd June 24, 2006
.Dt WSCONSCFG 8
.Os
.Sh NAME
.Nm wsconscfg
.Nd configure and switch between virtual terminals on a wscons display
.Sh SYNOPSIS
.Nm
.Op Fl e Ar emul
.Op Fl f Ar ctldev
.Op Fl t Ar type
.Ar index
.Nm
.Fl d
.Op Fl F
.Op Fl f Ar ctldev
.Ar index
.Nm
.Fl g
.Op Fl f Ar ctldev
.Nm
.Fl k | m
.Op Fl d
.Op Fl f Ar ctldev
.Op Ar index
.Nm
.Fl s
.Op Fl f Ar ctldev
.Ar index
.Sh DESCRIPTION
The
.Nm
tool allows to create, delete and switch between virtual terminals
on display devices controlled by the wscons terminal framework if
the underlying display hardware driver supports multiple screens.
Further it controls the assignment of keyboards to displays.
The
.Ar index
argument specifies which virtual terminal is to be configured; the
allowed numbers are from 0 to an implementation-specified value
(currently 7, allowing for 8 virtual terminals on a display).
In keyboard configuration mode, it specifies the
.Xr wskbd 4
device to attach or detach.
Without further option arguments, a virtual terminal is created
with implementation specific properties and a default terminal
emulation variant selected at kernel compile time.
.Pp
The options are:
.Bl -tag -width xxxxxxxxx
.It Fl d
Delete the specified terminal.
A terminal opened by a program will not be deleted unless the
.Fl F
option is applied.
Terminals used by the operating system console or a graphics program
(X server) cannot be deleted.
With the
.Fl k
flag, the keyboard specified by
.Ar index
will be detached from the wscons display.
With the
.Fl m
flag, the multiplexor specified by
.Ar index
will be detached from the wscons display.
.It Fl e Ar emul
Specify the terminal emulation to use for the virtual terminal.
The set of available terminal emulations is determined at kernel
compile time.
See
.Xr wscons 4
for details.
.It Fl F
Force deleting of a terminal even if it is in use by a user space
program.
.It Fl f Ar ctldev
Specify the control device of the wscons display to operate on.
Default is
.Pa /dev/ttyEcfg .
.It Fl g
Print the index of the current virtual terminal.
.It Fl k
Do keyboard related operations instead of virtual screen configuration.
Without other flags, a keyboard will be attached to the display
device.
The
.Ar index
argument can be omitted, in this case the first free keyboard will
be used.
.It Fl m
Do multiplexor related operations instead of virtual screen
configuration.
Without other flags, a multiplexor will be attached to the display
device.
.It Fl s
Switch to the specified virtual terminal.
.It Fl t Ar type
Specify a screen type to use.
Screen types refer to display format, colour depth and other
low-level display properties.
Valid
.Ar type
arguments are defined by the underlying display device driver.
.El
.Pp
Typically, the
.Nm
utility will be invoked in system startup by the
.Pa /etc/rc.d/wscons
script, controlled by the
.Pa /etc/wscons.conf
configuration file.
.Sh FILES
.Pa /etc/wscons.conf
.Sh EXAMPLES
.Dl wsconscfg -t 80x50 -e vt100 1
.Pp
Configure screen 1 (i.e., the second), it will get the type
.Ql 80x50
and use the VT100 terminal emulation.
(Note:
.Ql 80x50
is a screen type offered by the
.Xr vga 4
display driver.
In this particular case, an 8\(mu8-font must be loaded before to
make the screen useful.
See
.Xr wsfontload 8 . )
.Pp
.Dl wsconscfg -k
.Pp
Connect the first unconnected keyboard to the display.
.Pp
.Dl wsconscfg 3
.Pp
Create screen 3.
.Pp
.Dl wsconscfg -d 3
.Pp
Delete screen 3.
.Pp
.Dl wsconscfg -s 2
.Pp
Switch to screen 2.
.Sh SEE ALSO
.Xr wscons 4 ,
.Xr wskbd 4 ,
.Xr wsconsctl 8 ,
.Xr wsfontload 8
.Sh BUGS
There should be an easy way to get a list of the screen types
available on a display, and of the emulations supported by the
kernel.
